	/*
 * AtmegaBoard.cpp
 *
 * Created: 4/8/2013 4:31:13 PM
 *  Author: radhoo
 */ 


#include <avr/io.h>
#include "timeout.h"
#include "5110/5110.h"
#include "introscreen.h"
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "readdigipin.h"

LCD_5110 lcd;
ReadDigiPin pin_motor_1, pin_motor_2, pin_reset;

long counter = 1;
int sens = 1;

/*
	This interrupt handler is triggered each time a rising edge is
	detected on INT0, which on a ATmega8 is PD2
*/
ISR(INT0_vect)
{
	counter+= 1*sens;
	if (counter == 0) lcd.lcd_clear();
}

int main(void)
{
	_delay_ms(100);
	
	// define the 5 LCD Data pins: SCE, RST, DC, DATA, CLK
    lcd.lcd_init(&PORTD, PD5, //rst
		&PORTD, PD6, //ce
		&PORTD, PD7, //dc
		&PORTB, PB0, //data
		&PORTB, PB1);//clk
    
	
	/*
	 *  1.CONFIGURE INTERRUPT INT0  to count pulses from Geiger Counter, connected on PIN PD2
	 */
	// Configure INT0 to trigger on rising edge
	MCUCR |= _BV(ISC00) | _BV(ISC01);
	// Configure INT0 to fire interrupts
	GICR |= _BV(INT0);
	sei();

	

	// image demo
	lcd.printPictureOnLCD(introScreen);
	_delay_ms(1000);
	
	lcd.lcd_clear();
	
	// define polarity pins
	pin_motor_1.Init(&PIND, PD0);
	pin_motor_2.Init(&PIND, PD1);
	pin_reset.Init(&PINC, PC5);

	while (1) {
		
		// check polarity
		if (pin_motor_1.Get() == 1)
			sens = 1;
		else if (pin_motor_2.Get() == 1)
			sens = -1;
		//check reset
		if (pin_reset.Get() == 1) {
			sens = 1;
			counter = 0;
			lcd.lcd_clear();
		}			
		
		
		
		// limite
		if (counter >=99999) { counter = 0; lcd.lcd_clear(); }
		if (counter <=-99999) { counter = 0; lcd.lcd_clear(); }
		
		
		
		
		
		int d1 = abs((counter /10000) % 10),
			d2 = abs((counter / 1000) % 10),
			d3 = abs((counter /  100) % 10),
			d4 = abs((counter /   10) % 10),
			d5 = abs(counter % 10);
		if (counter < 0) 
			lcd.lcd_custom_number('-' + d1,0, 0, 1);
		lcd.lcd_custom_number('0' + d1,0, 1*0x0e, 1);
		lcd.lcd_custom_number('0' + d2,0, 2*0x0e, 1);
		lcd.lcd_custom_number('0' + d3,0, 3*0x0e, 1);
		lcd.lcd_custom_number('0' + d4,0, 4*0x0e, 1);
		lcd.lcd_custom_number('0' + d5,0, 5*0x0e, 1);
		
		// sens rotatie
		lcd.lcd_goto_xy(0,0);
		lcd.lcd_string_format("Numar de spire");
		//lcd.lcd_string_format("Numar %d %d", pin1.Get(), pin2.Get());
		lcd.lcd_goto_xy(0,5);
		if (sens == -1)
			lcd.lcd_string_format("Sens: invers -");
		else
			lcd.lcd_string_format("Sens: normal +");

		
		
		_delay_ms(100);
		
	}		
	
}